Strict
Framework brl.standardio
Import thunder.future

Function caesar:Object(so:Object)
	Local s:String = String(so)
	If s = Null Then Return Null
	
	Local s2:String, i
	For i = 0 Until s.length
		If s[i] >= Asc "A" And s[i] <= Asc "Z" Then
			s2 :+ Chr( (s[i] - Asc "A" + 3) Mod 26 + Asc "A" )
		Else If s[i] >= Asc "a" And s[i] <= Asc "z" Then
			s2 :+ Chr( (s[i] - Asc "a" + 3) Mod 26 + Asc "a" )
		Else
			s2 :+ Chr( s[i] )
		EndIf
	Next
	
	Return s2
EndFunction


Local strings:String[] = [	"miniBCC #26 - Tod durch Bildschirmkante",..
							"Aufgabe ", ..
							"Programmiert ein Spiel, bei dem es darum geht, ein oder mehrere Objekte im",..
							"Bildschirm oder im Fenster oder innerhalb eines im Fenster definierten", ..
							"Bereiches zu behalten. D.h. man verliert das Spiel genau dann, wenn", ..
							"(if and only if) eines, mehrere oder alle dieser Objekte diesen Bereich", ..
							"verlassen haben. " ]
Local crypt:Future[]

For Local s:String = EachIn strings
	crypt :+ [ Future.Create(caesar, s) ]
Next

For Local fut:Future = EachIn crypt
	Local s:String = String(fut.get())
	Print s
Next

End
