Strict
Framework brl.blitz
Import thunder.future
Import brl.math

Type LongInteger
	Field d:Long
	Function Create:LongInteger(d:Long)
		Local i:LongInteger = New LongInteger
		i.d = d
		Return i
	EndFunction
EndType

Function factor:Object(o:Object)
	Local intobj:LongInteger = LongInteger(o)
	Local x:Long = intobj.d
		
	Local factors:String = "1 "
	
	If x Mod 2 = 0 Then factors :+ "2 "
	
	' i know this is a bad method for factorization
	' this is on purpose
	
	For Local i:Long = 3:Long To x/2:Long
		If x Mod i = 0 Then factors :+ String(i)+" "
	Next
	
	factors :+ String(x)+" "
	
	Return factors
EndFunction

Function finished(fut:Future)
	If fut.bad() Then WriteStderr "error~n";Return

	Local intobj:LongInteger = LongInteger(fut.getParameter())
	Local x:Long = intobj.d, index

	WriteStderr "finished factorizing "+x+" : "+String(fut.get())+"~n"
EndFunction

Local arr:Long[] = [74:Long,  393974:Long, 89457783:Long, 28678233:Long, 2378974:Long, 7389912:Long, ..
					23984584:Long, 91263743:Long, 7822343:Long, 348374898:Long, 83:Long]

Local futures:CBFuture[]

Local time = MilliSecs()

For Local x:Long = EachIn arr
	futures :+ [CBFuture.Create(factor, LongInteger.Create(x), finished)]
Next

For Local fut:Future = EachIn futures
	fut.wait
Next

time = MilliSecs() - time
WriteStderr "time "+time+" ms~n"

	